cgicc: cgicc::HTMLBooleanElement< Tag > Class Template Reference

# cgicc::HTMLBooleanElement< Tag > Class Template Reference

Template for concrete boolean HTMLElement subclasses. More...

`#include <cgicc/HTMLBooleanElement.h>`

Inheritance diagram for cgicc::HTMLBooleanElement< Tag >:

List of all members.

## State Management
virtual void | swapState () const
| Swap the state of this boolean element.
virtual bool | getState () const
| Get the state of this boolean element.
static void | reset ()
| Reset the state of this boolean element to closed.
## Public Member Functions
virtual HTMLElement * | clone () const
| Clone this element.
virtual const char * | getName () const
| Get the name of this element. For example, "strong".
Constructors and Destructor
| HTMLBooleanElement ()
| Create a new empty boolean element.
| HTMLBooleanElement (const std::string &text)
| Create a new element, specifying the enclosed text.
| HTMLBooleanElement (const HTMLAttributeList &attributes)
| Create a new element, specifying the HTMLAttribute objects.
| HTMLBooleanElement (const HTMLElement &embedded)
| Create a new element, specifying an embedded HTMLElement.
| HTMLBooleanElement (const std::string &text, const HTMLAttributeList &attributes)
| Create a new element, specifying the enclosed text and HTMLAttribute objects.
| HTMLBooleanElement (const HTMLAttributeList &attributes, const HTMLElement &embed)
| Create a new element, specifying the HTMLAttributes and embedded HTMLElement.
virtual | ~HTMLBooleanElement ()
| Destructor.

## Detailed Description

### template<class Tag>
class cgicc::HTMLBooleanElement< Tag >

Template for concrete boolean HTMLElement subclasses.

A boolean HTML element is an element having a boolean (open or closed) state. Most commonly used HTML tags are boolean elements:

       <a href="http://www.gnu.org">GNU Project</a>

The `a` element is boolean, since it is either open or closed. Boolean elements are often additive:

       <b>bold text<i>bold italic text</i></b>

Note than under the XHTML 1.0 standard, elements may not overlap; ie, in the example above, it would be illegal to close the `b` tag before the `i` tag.

See also:
  HTMLElement

  HTMLAtomicElement

Definition at line 62 of file HTMLBooleanElement.h.

## Constructor & Destructor Documentation

template<class Tag>

cgicc::HTMLBooleanElement< Tag >::HTMLBooleanElement | ( | const std::string & | text | ) | `[inline]`

Create a new element, specifying the enclosed text.

Parameters:

  | text | The text within the element.

Definition at line 83 of file HTMLBooleanElement.h.

template<class Tag>

cgicc::HTMLBooleanElement< Tag >::HTMLBooleanElement | ( | const HTMLAttributeList & | attributes | ) | `[inline]`

Create a new element, specifying the HTMLAttribute objects.

Parameters:

  | attributes | The HTMLAttributes contained within the element.

Definition at line 91 of file HTMLBooleanElement.h.

template<class Tag>

cgicc::HTMLBooleanElement< Tag >::HTMLBooleanElement | ( | const HTMLElement & | embedded | ) | `[inline]`

Create a new element, specifying an embedded HTMLElement.

Parameters:

  | embedded | The HTMLElement embedded inside the element.

Definition at line 99 of file HTMLBooleanElement.h.

template<class Tag>

cgicc::HTMLBooleanElement< Tag >::HTMLBooleanElement | ( | const std::string & | text,
|  | const HTMLAttributeList & | attributes |
| ) |  |  | `[inline]`

Create a new element, specifying the enclosed text and HTMLAttribute objects.

Parameters:

  | attributes | The HTMLAttributes contained within the element.
  | text | The text within the element.

Definition at line 109 of file HTMLBooleanElement.h.

template<class Tag>

cgicc::HTMLBooleanElement< Tag >::HTMLBooleanElement | ( | const HTMLAttributeList & | attributes,
|  | const HTMLElement & | embed |
| ) |  |  | `[inline]`

Create a new element, specifying the HTMLAttributes and embedded HTMLElement.

Parameters:

  | attributes | The HTMLAttributes contained within the element.
  | embed | The HTMLElement embedded inside the element.

Definition at line 120 of file HTMLBooleanElement.h.

## Member Function Documentation

template<class Tag>

virtual HTMLElement* cgicc::HTMLBooleanElement< Tag >::clone | ( |  | ) | const`[inline, virtual]`

Clone this element.

Returns:
  A newly-allocated copy of this element

Implements cgicc::HTMLElement.

Definition at line 140 of file HTMLBooleanElement.h.

template<class Tag>

virtual const char* cgicc::HTMLBooleanElement< Tag >::getName | ( |  | ) | const`[inline, virtual]`

Get the name of this element. For example, "strong".

Returns:
  The name of this element

Implements cgicc::HTMLElement.

Definition at line 150 of file HTMLBooleanElement.h.

template<class Tag>

virtual void cgicc::HTMLBooleanElement< Tag >::swapState | ( |  | ) | const`[inline, virtual]`

Swap the state of this boolean element.

A state of `true` indicates the element is currently open

Reimplemented from cgicc::HTMLElement.

Definition at line 164 of file HTMLBooleanElement.h.

template<class Tag>

virtual bool cgicc::HTMLBooleanElement< Tag >::getState | ( |  | ) | const`[inline, virtual]`

Get the state of this boolean element.

Returns:
  `true` if this element is open, `false` otherwise

Reimplemented from cgicc::HTMLElement.

Definition at line 172 of file HTMLBooleanElement.h.

The documentation for this class was generated from the following file:

- HTMLBooleanElement.h